r2 = 11;    // kulatost plochy narazniku; polomer koule, ze ktere se vytvari
w = 5.3;    // sirka narazniku
h = 2.75;   // vyska narazniku
trn = 1.20; // trn pro nasunuti do kastle, prumer

t = 2;      // tloustka pruniku kvadr / koule udavajici tvar narazniku

module round_block(w, h, r, t = 1) {
    cube([t, w - 2*r, h - 2*r], center = true);
    $fn=50;
    minkowski() {
        cube([t, w - 2*r, h - 2*r], center = true);
        rotate([0, 90, 0]) cylinder(r = r,h = t/10, $fn=20, center=true);
    }
}

dl = 2.5 + 2.5 + 2.2;

translate([- (r2 -0.5) + dl, 0, 0])
intersection() {
    difference() {
        sphere(r2, $fa=1, $fs=0.1); 
        sphere(r2 - 0.4, $fa=1, $fs=0.1); 
    }
translate([r2 -0.5, 0, 0]) 
 round_block(w, h, 0.2, 2);
}


// trn pro nasunuti, d = 1.3mm
rotate([0, 90, 0]) cylinder(h=dl, d = trn, $fn = 50);
// tenci cat, pred naraznikem
translate([5, 0, 0]) rotate([0, 90, 0]) cylinder(h=2.5, d = 1.7, $fn = 50);
// tlustsi, stredni cast
translate([2.6, 0, 0]) rotate([0, 90, 0]) cylinder(h=2.6, d = 1.9, $fn = 50);